﻿using System;
using NetOffice;
using NetOffice.Attributes;
namespace NetOffice.DAOApi.Constants
{
	 /// <summary>
	 /// SupportByVersion DAO 3.6, 12.0
	 /// </summary>
	[SupportByVersion("DAO", 3.6,12.0)]
	[EntityType(EntityType.IsConstants)]
	public static class LanguageConstants
	{
		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangArabic = ";LANGID=0x0401;CP=1256;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangCzech = ";LANGID=0x0405;CP=1250;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangDutch = ";LANGID=0x0413;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangGeneral = ";LANGID=0x0409;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangGreek = ";LANGID=0x0408;CP=1253;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangHebrew = ";LANGID=0x040D;CP=1255;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangHungarian = ";LANGID=0x040E;CP=1250;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangIcelandic = ";LANGID=0x040F;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangNordic = ";LANGID=0x041D;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangNorwDan = ";LANGID=0x0406;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangPolish = ";LANGID=0x0415;CP=1250;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangCyrillic = ";LANGID=0x0419;CP=1251;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangSpanish = ";LANGID=0x040A;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangSwedFin = ";LANGID=0x041D;CP=1252;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangTurkish = ";LANGID=0x041F;CP=1254;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangJapanese = ";LANGID=0x0411;CP=932;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangChineseSimplified = ";LANGID=0x0804;CP=936;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangChineseTraditional = ";LANGID=0x0404;CP=950;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangKorean = ";LANGID=0x0412;CP=949;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangThai = ";LANGID=0x041E;CP=874;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 3.6, 12.0
		 /// </summary>
		[SupportByVersion("DAO", 3.6,12.0)]
		public const string dbLangSlovenian = ";LANGID=0x0424;CP=1250;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 12.0
		 /// </summary>
		[SupportByVersion("DAO", 12.0)]
		public const string dbLangJapaneseRadicalStrokeCount = ";LANGID=0x00040411;CP=65001;COUNTRY=0";

		 /// <summary>
		 /// SupportByVersion DAO 12.0
		 /// </summary>
		[SupportByVersion("DAO", 12.0)]
		public const string dbLangHindi = ";LANGID=0x00000439;CP=65001;COUNTRY=0";
	}
}